package cn.kdan.pdf.backend.core.controller;

import cn.kdan.pdf.backend.core.params.SubscriptionCreateParams;
import cn.kdan.pdf.backend.core.pojo.SubscriptionVO;
import cn.kdan.pdf.backend.core.service.SubscriptionService;
import constant.CommonConstant;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import pojo.ResultMap;

import javax.annotation.Resource;

/**
 * @author tangxiangan
 */
@RestController
@RequestMapping("/subscription")
public class SubscriptionController {

    @Resource
    private SubscriptionService subscriptionService;

    /**
     * 用户选择对应的服务类型 并且点击微信或者支付宝时调用 生成订阅和订单信息
     *
     * @param params SubscriptionCreateParams
     * @return SubscriptionVO
     */
    @PostMapping("create")
    public ResultMap<SubscriptionVO> create(@RequestBody SubscriptionCreateParams params) {
        return new ResultMap<>(CommonConstant.SUCCESS, CommonConstant.RESULT_SUCCESS, subscriptionService.create(params.getClient(), params.getPayment(), params.getTargetType(), params.getTargetId()));
    }
}
