package cn.kdan.pdf.backend.core.service;

import cn.kdan.pdf.backend.core.model.SocialAccounts;

/**
 * @author : SongFuQiang
 * @date : 2022/12/9 16:37
 */
public interface SocialAccountService {

    /**
     * 根据第三方账号id查询社交账号
     * @param accountId 第三方账号id
     * @return 社交账号信息
     */
    SocialAccounts selectByAccountId(String accountId);

    /**
     * 插入社交账号表数据
     * @param socialAccounts socialAccounts
     * @return
     */
    int insertSocialAccount(SocialAccounts socialAccounts);

    /**
     * 根据用户id查询社交账号表数据
     * @param userId 用户id
     * @return 社交账号信息
     */
    SocialAccounts selectByMemberId(String userId);

    /**
     * 根据用户id删除社交账号信息
     * @param memberId 用户ID
     */
    void deleteByMemberId(String memberId);
}
