package cn.kdan.pdf.backend.core.service.impl;

import cn.kdan.pdf.backend.core.mapper.SocialAccountsMapper;
import cn.kdan.pdf.backend.core.model.SocialAccounts;
import cn.kdan.pdf.backend.core.model.SocialAccountsExample;
import cn.kdan.pdf.backend.core.service.SocialAccountService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;

/**
 * @author SongFuQiang
 * @description
 */
@Slf4j
@Service
public class SocialAccountServiceImpl implements SocialAccountService {

    @Resource
    private SocialAccountsMapper socialAccountsMapper;

    @Override
    public SocialAccounts selectByAccountId(String accountId) {
        SocialAccountsExample example = new SocialAccountsExample();
        example.createCriteria().andAccountIdEqualTo(accountId);
        List<SocialAccounts> list = socialAccountsMapper.selectByExample(example);
        if (!CollectionUtils.isEmpty(list)) {
            return list.get(0);
        }
        return null;
    }

    @Override
    public int insertSocialAccount(SocialAccounts socialAccounts) {
        Date date = new Date();
        socialAccounts.setCreatedAt(date);
        socialAccounts.setUpdatedAt(date);
        socialAccountsMapper.insert(socialAccounts);
        return 0;
    }

    @Override
    public SocialAccounts selectByMemberId(String userId) {
        SocialAccountsExample example = new SocialAccountsExample();
        example.createCriteria().andMemberIdEqualTo(userId);
        List<SocialAccounts> list = socialAccountsMapper.selectByExample(example);
        if(CollectionUtils.isEmpty(list)){
            return null;
        }
        return list.get(0);
    }

    @Override
    public void deleteByMemberId(String memberId) {
        SocialAccountsExample example = new SocialAccountsExample();
        example.createCriteria().andMemberIdEqualTo(memberId);
        socialAccountsMapper.deleteByExample(example);
    }
}
